structure Cheater :> GAMEPLAYER =
struct
	(* play (ticket, low, high) = secret, ahol:
		- ticket a szerver ltal adott krdez csomag cme
		- low a legkisebb lehetsges szm
		- high a legnagyobb lehetsges szm
		- secret a megfejts, ha ez a kliens nyerte a jtkot, egybknt NONE
	 *)
	fun play (t, _, _) =
	let
		(* A krdez fggvnyeket tartalmaz struktra *)
		structure Connection = unpack (Remote.take t) : GAMECONNECTION
		(* A vgs megoldst a szerverrel kzl fggvny *)
		fun tell i = if Connection.solve (i,"Cheater") then SOME i else NONE handle Connection.Finished => NONE
		(* Egy gret, amibe a csal kilopja a szerver titkt *)
		val secret : int Promise.promise = Promise.promise ()
		(* A titkot ellopni hivatott fggvny *)
		fun steal x = (Promise.fulfill (secret, x); true)
		(* A tnylegesen krdsknt feltett fggvny *)
		val question = Remote.proxy steal
	in
		(Connection.ask question; tell (Promise.future secret)) handle Connection.Finished => NONE
	end
end
