(* load : unit -> unit
	A jtkhoz szksges szignatrk s struktrk betltse
 *)
fun load () =
let
	val it = use "gameconnection.sig"
	val it = use "gameplayer.sig"
	val it = use "gameserver.sig"
	val it = use "gameserver.sml"
	val it = use "stupidplayer.sml"
	val it = use "smartplayer.sml"
	val it = use "cheater.sml"
in
	()
end

(* play_fair : int -> string
	Egy jtk lejtszsa a megadott kitalland rtkkel s a kt tisztessge klienssel.
	A szerver s a kliensek is a loklis gpen futnak, de ez csak az egyszersg kedvrt van
	gy, a jtk mechanizmusa nem ignyeln.
 *)
fun play_fair secret =
let
	(* A szerver indtsa *)
	val (t, winner) = Gameserver.play secret
in
	spawn Stupidplayer.play(t,Gameserver.min,Gameserver.max);
	spawn Smartplayer.play(t,Gameserver.min,Gameserver.max);
	winner
end

(* play_unfair : int -> string
	Egy jtk lejtszsa a megadott kitalland rtkkel s mindhrom klienssel.
	A szerver s a kliensek is a loklis gpen futnak, de ez csak az egyszersg kedvrt van
	gy, a jtk mechanizmusa nem ignyeln.
 *)
fun play_unfair secret =
let
	(* A szerver indtsa *)
	val (t, winner) = Gameserver.play secret
in
	spawn Stupidplayer.play(t,Gameserver.min,Gameserver.max);
	spawn Smartplayer.play(t,Gameserver.min,Gameserver.max);
	spawn Cheater.play(t,Gameserver.min,Gameserver.max);
	winner
end
