structure Smartplayer :> GAMEPLAYER =
struct
	(* play (ticket, low, high) = secret, ahol:
		- ticket a szerver ltal adott krdez csomag cme
		- low a legkisebb lehetsges szm
		- high a legnagyobb lehetsges szm
		- secret a megfejts, ha ez a kliens nyerte a jtkot, egybknt NONE
	 *)
	fun play (t, low, high) =
	let
		(* A krdez fggvnyeket tartalmaz struktra *)
		structure Connection = unpack (Remote.take t) : GAMECONNECTION
		(* A vgs megoldst a szerverrel kzl fggvny *)
		fun tell i = if Connection.solve (i,"Smartplayer") then SOME i else NONE handle Connection.Finished => NONE
		(* A megoldst keres fggvny: binris keresssel prblja megtallni a helyes rtket *)
		fun try (l, h) =
		let
			val m = (l + h) div 2
		in
			if l = h then tell l else
				if Connection.ask (fn x => m < x) then try (m+1, h) else try (l, m)
			handle Connection.Finished => NONE
		end
	in
		try (low, high)
	end
end
